 /////////////////////////////////////////////////////////////
//
//  phpSecCheck version 1.1 [26 Dec 2002]
//  by Alex Stanev [http://sec.stanev.org] [alex@stanev.org]
//
//  This software only tries to help the human evaluation of
//  PHP  scripts.      It is in no way said it will find all
//  possible vulnerabilities in code. It should give you the
//  most obvious possibilities.      The point of using this
//  program is where you have to examine many lines of code.
//  Expect many false positives -  even if input variable is
//  properly filtered.
//     Good luck !
//
//////////////////////////////////////////////////////////////
//
//  Standard disclamer applies
//
//////////////////////////////////////////////////////////////

program phpSecCheck;

{$APPTYPE CONSOLE}

uses
  SysUtils, DateUtils, StrUtils, Classes;

const
  Danger : array [0..7]of String =         ('include(',
                                            'require(',
                                            'system(',
                                            'passthru(',
                                            'exec(',
                                            'unlink(',
                                            'include_once(',
                                            'require_once(');
var
  dtStart : TDateTime;

procedure ParseParameters;
begin
  if ParamCount < 1 then
  begin
    WriteLn('   Usage: ' + ExtractFileName(ParamStr(0)) + ' [filename.ext] : Scan single file');
    WriteLn('          ' + ExtractFileName(ParamStr(0)) + ' [directory]    : Recursive scans whole directory');
    Halt(1);
  end;
  if not (FileExists(ParamStr(1)) or
     DirectoryExists(ParamStr(1))) then
       begin
         WriteLn('   Parameter "' +ParamStr(1)+ '" is not file or directory');
         Halt(1);
       end;
end;

function SecCheckLine(Line : String) : Boolean;
var
  i,j     : Word;
  slLine  : TStringList;
begin
  Result := False;
  slLine := nil;
  try
    slLine := TStringList.Create;
  except
    slLine.Free;
    WriteLn('   Could not allocate memory');
    Exit;
  end;
  slLine.Text := StringReplace(Line,' ','',[rfIgnoreCase]);
  slLine.Text := StringReplace(slLine.Text,#7,'',[rfIgnoreCase]);
  slLine.Text := StringReplace(slLine.Text,';',#13#10,[rfIgnoreCase]);

  if slLine.Count > 0 then
    for i := 0 to slLine.Count - 1 do
      for j := 0 to High(Danger) do
        if Pos(Danger[j], LowerCase(slLine[i])) > 0 then
          if (Pos('$', RightStr(slLine[i], Length(slLine[i]) - Pos(Danger[j], LowerCase(slLine[i])))) > 0) then
          begin
            Result := True;
            Exit;
          end;
  slLine.Free;
end;

procedure SecCheckFile(FileName : String);
var
  i      : Word;
  Head   : Boolean;
  slFile : TStringList;
begin
  slFile := nil;
  try
    slFile := TStringList.Create;
    slFile.LoadFromFile(FileName);
  except
    slFile.Free;
    WriteLn('   Could not open ' + FileName);
    Exit;
  end;
  Head := True;
  if slFile.Count > 0 then
    for i := 0 to slFile.Count - 1 do
      if SecCheckLine(slFile[i]) then
      begin
        if Head then
        begin
          Head := False;
          WriteLn;
          WriteLn('Possible problems found in ' + FileName);
        end;
        WriteLn(IntToStr(i+1)+': '+Trim(slFile[i]));
      end;
  slFile.Free;
end;

procedure SecCheckDir(Entry : String);
var
  sr : TSearchRec;
begin
  if FileExists(Entry) then
  begin
    SecCheckFile(Entry);
    Exit;
  end;

  if RightStr(Entry, 1) <> '\' then
    Entry := Entry + '\';

  if FindFirst(Entry+'*.*', faAnyFile, sr) = 0 then
    repeat
      if ((sr.Attr and faDirectory) = faDirectory) and
        (sr.Name <> '.') and
        (sr.Name <> '..') then
          SecCheckDir(Entry + sr.Name)
      else
        if (LowerCase(ExtractFileExt(sr.Name)) = '.php') or
           (LowerCase(ExtractFileExt(sr.Name)) = '.php3') or
           (LowerCase(ExtractFileExt(sr.Name)) = '.inc') then
             SecCheckFile(Entry + sr.Name);
    until FindNext(sr) <> 0;
  FindClose(sr);
end;

begin
  WriteLn('phpSecCheck v1.1 by Alex Stanev [http://sec.stanev.org] 26 Dec 2002');

  ParseParameters;
  dtStart := Now;
  SecCheckDir(ParamStr(1));

  WriteLn;
  WriteLn('Work done in ' + IntToStr(SecondsBetween(Now, dtStart)) + ' sec');
end.
